//+------------------------------------------------------------------+
//|                                                 CCI Ma cross.mq4 |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     Red
#property indicator_color2     MediumSeaGreen
#property indicator_color3     LightSeaGreen
#property indicator_color4     LightSeaGreen
#property indicator_width1     2
#property indicator_width2     1
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern int    CciPeriod               = 50;
extern int    CciPrice                = PRICE_TYPICAL;
extern int    BandPeriod              = 20;
extern int    BandMaType              = MODE_EMA;
extern int    BandPrice               = PRICE_CLOSE;
extern double BandsDeviation          = 2.0; 
extern int    BandsMaMode             = MODE_EMA; 

extern double dnLevel                 = -150;
extern double upLevel                 = 150;

extern bool   alertsOn                = false;
extern bool   alertsOnOuterBandCross  = true;
extern bool   alertsOnCciMidBandCross = true;
extern bool   alertsOnCurrent         = true;
extern bool   alertsMessage           = true;
extern bool   alertsSound             = false;
extern bool   alertsEmail             = false;

extern bool   arrowsVisible           = false;
extern bool   arrowsOnOuterBandCross  = true;
extern bool   arrowsOnCciMidBandCross = true;
extern string arrowsIdentifier        = "cci arrows1";
extern double arrowsUpperGap          = 1.0;
extern double arrowsLowerGap          = 1.0;
extern color  arrowsUpColor           = LimeGreen;
extern color  arrowsDnColor           = Red;
extern int    arrowsUpCode            = 221;
extern int    arrowsDnCode            = 222;

//
//
//
//
//

double cci[];
double cciMa[];
double upMa[];
double dnMa[];
double prices[];
double trend1[];
double trend2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,cci);
      SetIndexBuffer(1,cciMa);
      SetIndexBuffer(2,upMa); 
      SetIndexBuffer(3,dnMa); 
      SetIndexBuffer(4,prices);
      SetIndexBuffer(5,trend1);
      SetIndexBuffer(6,trend2);
      SetLevelValue(0,upLevel);
      SetLevelValue(1,dnLevel);
      
      
   IndicatorShortName("Cci Bands ("+CciPeriod+","+BandPeriod+")");
return(0);
}

int deinit()
{
   deleteArrows();
   
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      prices[i]  = iMA(NULL,0,1,0,MODE_SMA,CciPrice,i);
      double avg = 0; for(k=0; k<CciPeriod; k++) avg +=         prices[i+k];      avg /= CciPeriod;
      double dev = 0; for(k=0; k<CciPeriod; k++) dev += MathAbs(prices[i+k]-avg); dev /= CciPeriod;
         if (dev!=0)
               cci[i] = (prices[i]-avg)/(0.015*dev);
         else  cci[i] = 0;          
   }
   
   for(i=limit; i>=0; i--)
   {
      double StdDev    = iStdDevOnArray(cci,0,BandPeriod,0,BandMaType,i);
      double cciavg    = iMAOnArray(cci,0,BandPeriod,0,BandMaType,i);
             upMa[i]   = cciavg + (StdDev*BandsDeviation);
             dnMa[i]   = cciavg - (StdDev*BandsDeviation);
             cciMa[i]  = cciavg;
             trend1[i] = trend1[i+1];
             trend2[i] = trend2[i+1];
                if (upMa[i]>upLevel && upMa[i+1]<=upLevel) trend1[i] = 1;
                if (dnMa[i]<dnLevel && dnMa[i+1]>=dnLevel) trend1[i] =-1;
                if (cci[i]>cciMa[i])                       trend2[i] = 1;
                if (cci[i]<cciMa[i])                       trend2[i] =-1;
                manageArrow(i);      
   }
   manageAlerts();
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      deleteArrow(Time[i]);
      string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
      if (arrowsOnOuterBandCross && trend1[i] != trend1[i+1])
      {
         if (trend1[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
         if (trend1[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode, true);
      } 
      if (arrowsOnCciMidBandCross && trend2[i] != trend2[i+1])
      {
         if (trend2[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
         if (trend2[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode, true);
      }                 
   }         
}       

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
    string name = arrowsIdentifier+":"+Time[i];
    double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnOuterBandCross && trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar," upper band crossed up level");
            if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar," lower band crossed down level");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnCciMidBandCross && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar," cci crossed middle band up");
            if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar," cci crossed middle band down");
         }            
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol(),TimeToStr(TimeLocal(),TIME_SECONDS)," Cci Bands trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Cci Bands "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}